import type { InspectionPlanViewModel } from "@/viewmodels/admin/unit/inspectionPlan/inspectionPlan.models";
import type {
  InspectionPointViewModel,
  InspectionPointResultViewModel,
  InspectionViewModel,
} from "@/viewmodels/admin/unit/inspection/inspection.models";

export const inspectionPointDemoData: Array<InspectionPointViewModel> = [
  {
    id: "edf",
    title: "vorhandene Spritzstellen ausgebessert",
    description: "",
    type: "number",
  },
  {
    id: "ghi",
    title: "Einband der Kupplung sitzt fest",
    description: "",
    type: "iO-niO",
  },
  {
    id: "lmn",
    title: "Das überstehende Drahtende des Knaggenteiles sitzt versenkt",
    description: "",
    type: "iO-niO",
  },
  {
    id: "jgj",
    title: "Gebrauchsprüfdruck 12bar",
    description: "",
    type: "iO-niO",
  },
];

export const inspectionPlanDemoData: Array<InspectionPlanViewModel> = [
  {
    id: "abc",
    title: "Sichtprüfung",
    version: 1,
    inspectionInterval: "1-m",
    remindTime: "1-m",
    created: new Date(),
    inspectionPoints: [inspectionPointDemoData[0], inspectionPointDemoData[1], inspectionPointDemoData[2]],
    relatedId: "xyz",
    related: {
      id: "xyz",
      type: "B-Schlauch",
      description: "Shläuche vom Typ B",
      inspectionPlans: [],
    },
  },
  {
    id: "cba",
    title: "Druckprüfung",
    version: 1,
    inspectionInterval: "1-m",
    remindTime: "22/10",
    created: new Date(),
    inspectionPoints: [inspectionPointDemoData[3]],
    relatedId: "xyz",
    related: {
      id: "xyz",
      type: "B-Schlauch",
      description: "Shläuche vom Typ B",
      inspectionPlans: [],
    },
  },
];

export const inspectionPointResultDemoData: Array<InspectionPointResultViewModel> = [
  {
    inspectionId: "jkvshdfg",
    inspectionVersionedPlanId: inspectionPlanDemoData[0].id,
    inspectionPointId: inspectionPointDemoData[0].id,
    value: "5",
  },
  {
    inspectionId: "jkvshdfg",
    inspectionVersionedPlanId: inspectionPlanDemoData[0].id,
    inspectionPointId: inspectionPointDemoData[1].id,
    value: "",
  },
  {
    inspectionId: "jkvshdfg",
    inspectionVersionedPlanId: inspectionPlanDemoData[0].id,
    inspectionPointId: inspectionPointDemoData[1].id,
    value: "",
  },
];

export const inspectionDemoData: Array<InspectionViewModel> = [
  {
    id: "jkvshdfg",
    inspectionPlanId: inspectionPlanDemoData[0].id,
    inspectionPlan: inspectionPlanDemoData[0],
    inspectionVersionedPlanId: inspectionPlanDemoData[0].id,
    inspectionVersionedPlan: inspectionPlanDemoData[0],
    context: "",
    created: new Date(),
    finished: undefined,
    nextInspection: undefined,
    isOpen: true,
    checks: [inspectionPointResultDemoData[0], inspectionPointResultDemoData[1], inspectionPointResultDemoData[2]],
    relatedId: "abc",
    related: {
      id: "abc",
      code: "0456984224498",
      name: "B-Schlauch",
      location: "HLF",
      equipmentTypeId: "xyz",
      equipmentType: {
        id: "xyz",
        type: "B-Schlauch",
        description: "Shläuche vom Typ B",
        inspectionPlans: [],
      },
      inspections: [],
    },
  },
  {
    id: "jkvshdfg",
    inspectionPlanId: inspectionPlanDemoData[0].id,
    inspectionPlan: inspectionPlanDemoData[0],
    inspectionVersionedPlanId: inspectionPlanDemoData[0].id,
    inspectionVersionedPlan: inspectionPlanDemoData[0],
    context: "sohgfpb",
    created: new Date(),
    finished: new Date(),
    nextInspection: new Date(),
    isOpen: false,
    checks: [inspectionPointResultDemoData[0], inspectionPointResultDemoData[1], inspectionPointResultDemoData[2]],
    relatedId: "abc",
    related: {
      id: "abc",
      code: "0456984224498",
      name: "B-Schlauch",
      location: "HLF",
      equipmentTypeId: "xyz",
      equipmentType: {
        id: "xyz",
        type: "B-Schlauch",
        description: "Shläuche vom Typ B",
        inspectionPlans: [],
      },
      inspections: [],
    },
  },
];
