import { defineStore } from "pinia";
import type {
  EquipmentTypeViewModel,
  CreateEquipmentTypeViewModel,
  UpdateEquipmentTypeViewModel,
} from "@/viewmodels/admin/unit/equipmentType/equipmentType.models";
import { http } from "@/serverCom";
import type { AxiosResponse } from "axios";
import { equipmentTypeDemoData } from "@/demodata/equipmentType";
import type { InspectionPlanViewModel } from "@/viewmodels/admin/unit/inspectionPlan/inspectionPlan.models";
import { inspectionPlanDemoData } from "@/demodata/inspectionPlan";
import { useEquipmentTypeStore } from "./equipmentType";

export const useEquipmentTypeInspectionPlanStore = defineStore("equipmentTypeInspectionPlan", {
  state: () => {
    return {
      inspectionPlans: [] as Array<InspectionPlanViewModel>,
      loading: "loading" as "loading" | "fetched" | "failed",
    };
  },
  actions: {
    fetchInspectionPlanForEquipmentType() {
      const equipmentTypeId = useEquipmentTypeStore().activeEquipmentType;
      this.inspectionPlans = inspectionPlanDemoData.filter((ipdd) => ipdd.relatedId == equipmentTypeId);
      this.loading = "fetched";
      return;
      this.loading = "loading";
      http
        .get(`/admin/equipmentType/${equipmentTypeId}/inspectionPlan`)
        .then((result) => {
          this.inspectionPlans = result.data;
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
  },
});
