import { defineStore } from "pinia";
import { http } from "@/serverCom";
import { useVehicleStore } from "./vehicle";
import type { DamageReportViewModel } from "@/viewmodels/admin/unit/damageReport/damageReport.models";
import { damageReportDemoData } from "@/demodata/damageReport";

export const useVehicleDamageReportStore = defineStore("vehicleDamageReport", {
  state: () => {
    return {
      damageReports: [] as Array<DamageReportViewModel & { tab_pos: number }>,
      totalCount: 0 as number,
      loading: "loading" as "loading" | "fetched" | "failed",
    };
  },
  actions: {
    fetchDamageReportForVehicle(offset = 0, count = 25, search = "", clear = false) {
      const vehicleId = useVehicleStore().activeVehicle;
      this.damageReports = damageReportDemoData
        .filter((drdd) => drdd.relatedId == vehicleId)
        .map((e, i) => ({ ...e, tab_pos: i }));
      this.totalCount = this.damageReports.length;
      this.loading = "fetched";
      return;
      if (clear) this.damageReports = [];
      this.loading = "loading";
      http
        .get(
          `/admin/vehicle/${vehicleId}/damageReport?offset=${offset}&count=${count}${search != "" ? "&search=" + search : ""}`
        )
        .then((result) => {
          this.totalCount = result.data.total;
          result.data.reports
            .filter((elem: DamageReportViewModel) => this.damageReports.findIndex((m) => m.id == elem.id) == -1)
            .map((elem: DamageReportViewModel, index: number): DamageReportViewModel & { tab_pos: number } => {
              return {
                ...elem,
                tab_pos: index + offset,
              };
            })
            .forEach((elem: DamageReportViewModel & { tab_pos: number }) => {
              this.damageReports.push(elem);
            });
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
  },
});
