import { defineStore } from "pinia";
import type {
  VehicleTypeViewModel,
  CreateVehicleTypeViewModel,
  UpdateVehicleTypeViewModel,
} from "@/viewmodels/admin/unit/vehicleType/vehicleType.models";
import { http } from "@/serverCom";
import type { AxiosResponse } from "axios";
import { vehicleTypeDemoData } from "@/demodata/vehicleType";
import type { InspectionPlanViewModel } from "@/viewmodels/admin/unit/inspectionPlan/inspectionPlan.models";
import { inspectionPlanDemoData } from "@/demodata/inspectionPlan";
import { useVehicleTypeStore } from "./vehicleType";

export const useVehicleTypeInspectionPlanStore = defineStore("vehicleTypeInspectionPlan", {
  state: () => {
    return {
      inspectionPlans: [] as Array<InspectionPlanViewModel>,
      totalCount: 0 as number,
      loading: "loading" as "loading" | "fetched" | "failed",
    };
  },
  actions: {
    fetchInspectionPlanForVehicleType() {
      const vehicleTypeId = useVehicleTypeStore().activeVehicleType;
      this.inspectionPlans = inspectionPlanDemoData.filter((ipdd) => ipdd.relatedId == vehicleTypeId);
      this.loading = "fetched";
      return;
      this.loading = "loading";
      http
        .get(`/admin/vehicleType/${vehicleTypeId}/inspectionPlan`)
        .then((result) => {
          this.inspectionPlans = result.data;
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
  },
});
